﻿using System.Runtime.InteropServices.JavaScript;
using System.Runtime.Versioning;

namespace SimpleVoiceChat.BlazorWasm
{
    [SupportedOSPlatform("browser")]
    public static partial class SvcAudioCaptureModule
    {
        public static Action OnInit;
        public static Action<byte[]> ChunkArrive;

        private static JSObject _jsModule;

        public static async Task<bool> Init()
        {
            _jsModule ??= await JSHost.ImportAsync("SvcAudioCaptureModule", $"{SvcGlobal.BasePath ?? "/"}svc-audio-capture-module.js");
            return await JsInit();
        }

        public static async Task Start() => await JsStart();

        public static async Task Stop() => await JsStop();

        [JSImport("init", "SvcAudioCaptureModule")]
        private static partial Task<bool> JsInit();

        [JSImport("start", "SvcAudioCaptureModule")]
        private static partial Task JsStart();

        [JSImport("stop", "SvcAudioCaptureModule")]
        private static partial Task JsStop();

        [JSExport]
        private static void JsFeedChunk(byte[] chunk)
        {
            Console.WriteLine("chunk");
            if (ChunkArrive != null) ChunkArrive(chunk);
        }

        [JSExport]
        private static void JsInitCallBack(bool value)
        {
            if (OnInit != null) OnInit();
        }
    }
}
